
function onBodyLoad() {
    document.addEventListener("deviceready", onDeviceReady, false);
};

function onDeviceReady() {
	
    isPhoneGap = true;
	navigator.splashscreen.hide();
	MobiScout.Tab.AutoLogonPlanner();
	FastClick.attach(document.body);
    document.addEventListener("pause", appPaused, false);
    document.addEventListener("resume", appResumed, false);
    document.addEventListener("online", appOnline, false);
    document.addEventListener("offline", appOffline, false);
    document.addEventListener("backbutton", appBackKeyDown, false);
    document.addEventListener("menubutton", appMenuButton, false);
    window.addEventListener("batterycritical", appBatteryCritical, false); // was window.addEventListener
    window.addEventListener("batterylow", appBatteryLow, false);	// was window.addEventListener
    window.addEventListener("batterystatus", appBatteryStatus, false);	// was window.addEventListener
    
    // Loading the google maps API breaks the application on Android 4.4
    // why? No idea!
    
    loadMapsApi();
    
};

$.fn.animateRotate = function(angle, duration, easing, complete) {
  var args = $.speed(duration, easing, complete);
  var step = args.step;
  return this.each(function(i, e) {
    args.complete = $.proxy(args.complete, e);
    args.step = function(now) {
      $.style(e, 'transform', 'rotate(' + now + 'deg)');
      if (step) return step.apply(e, arguments);
    };

    $({deg: 0}).animate({deg: angle}, args);
  });
};

checkGoogleMapsPresence = function(){
	if(google){
		if(google.maps) return true;
	}
	return false;
}



loadMapsApi = function () {
	try{
	    if(navigator.connection.type === Connection.NONE || checkGoogleMapsPresence() == true) {
	            return;
	    }
    }
    catch(Err){
    	//console.log("Error checking for google maps presence: " + Err);
    }
    if(apiLoaded == false){
    	apiLoaded = true;
    	//$.getScript('https://maps.googleapis.com/maps/api/js?sensor=true&callback=onMapsApiLoaded');
    	// indien kitkat of lager: 3.25 laden
    	// anders standaard laden
    	if(window.MobiScoutApp){
    		if(window.MobiScoutApp.IsOlderDevice() == true){
    			MobiScout.Tab.LogToConsole("Loading 3.25 version of google maps");
    			$.getScript('https://maps.googleapis.com/maps/api/js?v=3.25&callback=onMapsApiLoaded');
    		}
    		else{
    			MobiScout.Tab.LogToConsole("Loading latest version of google maps");
    			$.getScript('https://maps.googleapis.com/maps/api/js?callback=onMapsApiLoaded');
    		}
    	}
    	else{
   			MobiScout.Tab.LogToConsole("Loading latest version of google maps");
    		$.getScript('https://maps.googleapis.com/maps/api/js?callback=onMapsApiLoaded');
    	}
   		
    }
}

onMapsApiLoaded = function () {
	apiLoaded = true;
	try{
		MobiScout.Tab.Mapping.HTMLMarker.prototype = new google.maps.OverlayView();
		MobiScout.Tab.Mapping.HTMLMarker.prototype.onRemove = function () {}
		MobiScout.Tab.Mapping.HTMLMarker.prototype.onAdd = function () {
		        div = document.createElement('DIV');
		        div.style.position='absolute';
		        div.className = "htmlMarker";
		        div.innerHTML = '<img src="images/maintenance-time.png" style="width:24px;height:24px">';
		        var panes = this.getPanes();
		        panes.overlayImage.appendChild(div);
		        this.div=div;
		        
		};
		
		MobiScout.Tab.Mapping.HTMLMarker.prototype.draw = function () {
		        var position = this.getProjection().fromLatLngToDivPixel(this.pos);
		        this.div.style.left = position.x - 12 + 'px';
		        this.div.style.top = position.y - 12 + 'px';
		};
		
	    try {
	        $('#map_canvas').gmap({'disableDefaultUI':true});
	        $.mobile.loadPage("#map");
	   	}
	   	catch (Err) {
	   		MobiScout.Tab.LogToConsole("loaded error: " + Err);
	   	}
	   	if(MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		   	MobiScout.Tab.App.LogonRetries = 5;
		   	MobiScout.Tab.AutoLogonPlanner();
	   	}
	 }catch(ErrMaps){
	 	MobiScout.Tab.LogToConsole("Failed to load maps: " + ErrMaps);
	 }
};

function appPaused() {
	try
	{
	   MobiScout.Tab.App.isAppPaused = true;
		jQuery.fx.off = true;
	}
	catch(Err)
	{}

};

function reviveApp(){

    // altijd sessie controleren
   
}

function appResumed() {
	try
	{
	    MobiScout.Tab.App.isAppPaused = false;
	    MobiScout.Tab.Data.checkSession();
	    if ($('.ui-page-active').attr('id') == 'messages') {
	    	MobiScout.Tab.ClearAndroidNotification();
	    }
    	jQuery.fx.off = false;
    	loadMapsApi();	
	}
	catch(Err)
	{}

};



function appOnline() {
	loadMapsApi();
};

function appOffline() {
};

function appBackKeyDown() {
	var vehicleMenuClosed = MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	var sidenav = $("#menu");
	var sideNavHidden = sidenav.css("visibility") == "hidden" || sidenav.css("overflow-x") == "hidden" || sidenav.css("overflow-y") == "hidden";
	if(sideNavHidden == false){
		sidenav.panel('close');
		return;
	}
	
	var sidenavcontext = $("#contextmenu");
	var sideNavContextHidden = sidenavcontext.css("visibility") == "hidden" || sidenavcontext.css("overflow-x") == "hidden" || sidenavcontext.css("overflow-y") == "hidden";
	if(sideNavContextHidden == false){
		sidenavcontext.panel('close');
		return;
	}
	
	if ($('.ui-page-active').attr('id') == 'home') {
		sidenav.panel('close');
		sidenavcontext.panel('close');
		// dit niet doen indien het circulaire menu open was in het voertuigenscherm!
		if(vehicleMenuClosed == true) return;
		scroll(0,0);
		try{
			if(window.MobiScoutApp) window.MobiScoutApp.RevertToBackground();
		}catch(Err){}
	}
	else if ($('.ui-page-active').attr('id') == 'messages') { 
		// van messages terug, altijd naar home
		if(MobiScout.Tab.App.LastPageID == "home"){
			// dan gewoon terug
			history.back();
		}
		else{
			MobiScout.Tab.ChangePage("home");
		}
	}
	else if ($('.ui-page-active').attr('id') == 'messagedialog') { 
		// van messagedialog terug, altijd naar home
		if(MobiScout.Tab.App.LastPageID == "home"){
			// dan gewoon terug
			history.back();
		}
		else{
			MobiScout.Tab.ChangePage("home");
		}
	}
	else if ($('.ui-page-active').attr('id') == 'employees') { 
		// van employees terug, altijd naar home
		if(MobiScout.Tab.App.LastPageID == "home"){
			// dan gewoon terug
			history.back();
		}
		else{
			MobiScout.Tab.ChangePage("home");
		}
	}
	else if ($('.ui-page-active').attr('id') == 'temperature') { 
		if(MobiScout.Tab.App.LastPageID == "home") history.back();
		else MobiScout.Tab.ChangePage("home");
	}
	else if ($('.ui-page-active').attr('id') == 'periodView') { 
		if(MobiScout.Tab.App.LastPageID == "home") history.back();
		else MobiScout.Tab.ChangePage("home");
	}
	else if ($('.ui-page-active').attr('id') == 'realtimeHours') { 
		if(MobiScout.Tab.App.LastPageID == "home") history.back();
		else MobiScout.Tab.ChangePage("home");
	}
	else{
		history.back();
	}
	//return false;
};

function appBatteryCritical(info) {
};

function appBatteryLow(info) {
};

function appBatteryStatus(info) {
};

function appMenuButton() {
	var sidenav = $("#menu");
	var sideNavHidden = sidenav.css("visibility") == "hidden" || sidenav.css("overflow-x") == "hidden" || sidenav.css("overflow-y") == "hidden";
	if(sideNavHidden == false){
		sidenav.panel('close');
		return;
	}

	var sidenavcontext = $("#contextmenu");
	var sideNavContextHidden = sidenavcontext.css("visibility") == "hidden" || sidenavcontext.css("overflow-x") == "hidden" || sidenavcontext.css("overflow-y") == "hidden";
	if(sideNavContextHidden == false){
		sidenavcontext.panel('close');
		return;
	}

	sidenav.panel('open');
};

function appSearchButton() {
};

function hideKeyboard(element) {
    element.attr('readonly', 'readonly'); // Force keyboard to hide on input field.
    element.attr('disabled', 'true'); // Force keyboard to hide on textarea field.
    setTimeout(function() {
        element.blur();  //actually close the keyboard
        // Remove readonly attribute after keyboard is hidden.
        element.removeAttr('readonly');
        element.removeAttr('disabled');
    }, 500);
}

function androidSoftKeyHideFix(selectorName){
    $(selectorName).on('focus', function (event) {
        $(selectorName).off('focus')
        $('body').on('touchend', function (event) {
            $('body').off('touchend')
            $('.blurBox').focus();
            setTimeout(function() {
                $('.blurBox').blur();
                $('.blurBox').focus();
                $('.blurBox').blur();
                androidSoftKeyHideFix(selectorName); 
            },1)
        });
    });
}    


$(document).bind("mobileinit", function () {
    jQuery.support.cors = true;
    $.mobile.page.prototype.options.addBackBtn = true; // <GS-02032012>
    $.mobile.page.prototype.options.backBtnText = "Terug";
    $.mobile.page.prototype.options.backBtnTheme = "e";
  	$.mobile.loader.prototype.options.text = "even geduld";
    $.mobile.allowCrossDomainPages = true;
    
    $.event.special.tap.emitTapOnTaphold = false;
    $.event.special.swipe.scrollSupressionThreshold = scrollSupressionThreshold;
    $.event.special.swipe.horizontalDistanceThreshold = horizontalDistanceThreshold;


     try{
        	isChrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
    }
    catch(Err){}
    if(isChrome == true){
	    $.ajaxSetup({
	        cache: false,
	        crossDomain: true,
	        timeout: connectionTimeout,
	        headers: {
	            'Cache-Control': 'no-cache',
	            'Access-Control-Allow-Origin': '*'
	        }
	    });
    }
    else{
	    $.ajaxSetup({
	        cache: false,
	        crossDomain: true,
	        timeout: connectionTimeout,
	        headers: {
	            'Cache-Control': 'no-cache',
	            'Access-Control-Allow-Origin': '*',
	            'Accept-Encoding': 'gzip, deflate' 
	        }
	    });
    }
    
    $(document).on("pageinit", '#map', function () {
		if(MobiScout.Tab.App.MapCentered == false){
        	MobiScout.Tab.Mapping.InitializeMapOnNetherlands();
        }
	} );
    
});

