

MobiScout.Tab.Mapping.plotArray = new Array();
MobiScout.Tab.Mapping.actArray = new Array();
MobiScout.Tab.Mapping.CurrentZoom;
MobiScout.Tab.Mapping.CurrentCenter;
MobiScout.Tab.Mapping.TrafficInitialized = false;
MobiScout.Tab.Mapping.VisibleDepartmentID = -1;
MobiScout.Tab.Mapping.trafficLayer;
MobiScout.Tab.Mapping.ClustererInitialized = false;
MobiScout.Tab.Mapping.clusterLayer;


MobiScout.Tab.Mapping.HTMLMarker = function(lat, lng) {
        this.lat = lat;
        this.lng = lng;
        this.pos = new google.maps.LatLng(lat, lng);
    }


MobiScout.Tab.Mapping.ClearMap = function(){

	MobiScout.Tab.Mapping.clearTemporaryPosition();
	MobiScout.Tab.Mapping.RemoveActivityPins();
	MobiScout.Tab.Mapping.clearOverlays();
	MobiScout.Tab.Mapping.clearPolylines();
	MobiScout.Tab.Mapping.clearRectangles();
	MobiScout.Tab.Mapping.clearPolygones();
	MobiScout.Tab.Mapping.clearCircles();
	MobiScout.Tab.Mapping.VisibleDepartmentID = -1;
	MobiScout.Tab.Mapping.CheckAllMarkersVisibility();
}


MobiScout.Tab.Mapping.ShowAllOnMap = function(){
	MobiScout.Tab.Mapping.VisibleDepartmentID = -1;
	MobiScout.Tab.Mapping.CheckAllMarkersVisibility();
}

MobiScout.Tab.Mapping.ShowGroupOnMap = function(departmentID){
	//console.log("MobiScout.Tab.Mapping.ShowGroupOnMap: " + departmentID);
	MobiScout.Tab.Mapping.VisibleDepartmentID = departmentID;
	MobiScout.Tab.Mapping.CheckAllMarkersVisibility();
	MobiScout.Tab.Mapping.ZoomToVehicles();
	// zoom to markers
}

MobiScout.Tab.Mapping.ZoomToVehicles = function(){
	//console.log("MobiScout.Tab.Mapping.ZoomToVehicles");
	try{
		var bounds = new google.maps.LatLngBounds();
		$('#map_canvas').gmap('find', 'markers', { }, function(marker) {
			try{
				if(marker.getVisible() == true){
					bounds.extend(marker.position);
				}
			}
			catch(Err){
				console.log("Failed to handle marker: " + Err);
			}
		});
		var map = $("#map_canvas").gmap("get", "map");
		map.fitBounds(bounds);
		//MobiScout.Tab.Mapping.ZoomIn();
		//MobiScout.Tab.Mapping.ZoomOut();
		//google.maps.event.trigger(map, 'resize');
		//MobiScout.Tab.Mapping.ResizeMap();
	}
	catch(Err2){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Mapping.ZoomToVehicles: " + Err2);
	}
}

MobiScout.Tab.Mapping.ResizeMap = function(){
	try{
		var map = $("#map_canvas").gmap("get", "map");
		google.maps.event.trigger(map, 'resize');
	}catch(Err){
	}
}

MobiScout.Tab.Mapping.ZoomIn = function(){
	try{
		//console.log("Zoomin: current zoom: " + Number($('#map_canvas').gmap('option', 'zoom')) + " vs CurrentZoom " + MobiScout.Tab.Mapping.CurrentZoom);
		if(MobiScout.Tab.Mapping.CurrentZoom) $('#map_canvas').gmap('option', 'zoom', MobiScout.Tab.Mapping.CurrentZoom + 1);
		else $('#map_canvas').gmap('option', 'zoom', Number($('#map_canvas').gmap('option', 'zoom')) + 1);
	}
	catch(Err){
	}
}

MobiScout.Tab.Mapping.ZoomOut = function(){
	try{
		//console.log("Zoomout: current zoom: " + Number($('#map_canvas').gmap('option', 'zoom')) + " vs CurrentZoom " + MobiScout.Tab.Mapping.CurrentZoom);
		if(MobiScout.Tab.Mapping.CurrentZoom) $('#map_canvas').gmap('option', 'zoom', MobiScout.Tab.Mapping.CurrentZoom - 1);
		else $('#map_canvas').gmap('option', 'zoom', Number($('#map_canvas').gmap('option', 'zoom')) - 1);
	}
	catch(Err){
	}
}

MobiScout.Tab.Mapping.clearMarkers = function(){
	$('#map_canvas').gmap('find', 'markers', { }, function(marker) {
		marker.setVisible(false);
		marker.setMap(null);
		marker=null;
	});
};

MobiScout.Tab.Mapping.clearOverlays = function(){
		$("#map_canvas").gmap('clear', 'overlays');
	};

MobiScout.Tab.Mapping.clearCircles = function(){
		$("#map_canvas").gmap('clear', 'overlays > Circle');
	};
	
MobiScout.Tab.Mapping.clearPolylines = function(){
		$("#map_canvas").gmap('clear', 'overlays > Polyline');
	};
	
MobiScout.Tab.Mapping.clearPolygones = function(){
		$("#map_canvas").gmap('clear', 'overlays > Polygon');
	};
	
MobiScout.Tab.Mapping.clearRectangles = function(){
		$("#map_canvas").gmap('clear', 'overlays > Rectangle');
	};
	
MobiScout.Tab.Mapping.StartPlotVehicleRouteOnMap = function(vehicleid, dateToPlot){
		MobiScout.Tab.Mapping.clearPolylines();
		MobiScout.Tab.Mapping.RemoveActivityPins();
		MobiScout.Tab.Mapping.plotArray.splice(0, MobiScout.Tab.Mapping.plotArray.length);
		MobiScout.Tab.Mapping.actArray.splice(0, MobiScout.Tab.Mapping.actArray.length);
		MobiScout.Tab.Data.getRouteForVehicleV2(vehicleid, dateToPlot);
		
	};
	
MobiScout.Tab.Mapping.AddPlotLocation = function(latitude, longitude, activityid){
		MobiScout.Tab.Mapping.plotArray.push(new google.maps.LatLng(latitude, longitude));
		if(activityid > 0 && activityid != 960){
			try{
				var actPlotLocation = new PlotLocation();
				actPlotLocation.ActivityID = activityid;
				actPlotLocation.ActivityDescr = MobiScout.Tab.App.getActivityDescription(activityid);
				actPlotLocation.Latitude = latitude;
				actPlotLocation.Longitude = longitude;
				MobiScout.Tab.Mapping.actArray.push(actPlotLocation);
			}
			catch(Err){
				console.log("AddPlotLocation: " + Err);
			}
		}
	}
	
MobiScout.Tab.Mapping.SetPlotBounds = function(){	
	/*$('#map_canvas').gmap('set', 'bounds', null);
		for (var i=0; i<MobiScout.Tab.Mapping.plotArray.length; i++) {
	  		$('#map_canvas').gmap('addBounds', MobiScout.Tab.Mapping.plotArray[i]);
	  	} */
	var bounds = new google.maps.LatLngBounds();
	for (var i=0; i < MobiScout.Tab.Mapping.plotArray.length; i++) {
		bounds.extend(MobiScout.Tab.Mapping.plotArray[i]);
	}
	var map = $("#map_canvas").gmap("get", "map");
	// check, bounds are OK!
	map.fitBounds(bounds);
};


MobiScout.Tab.Mapping.RemoveClusterer = function(){
	//console.log("RemoveClusterer");
	try{
		if(MobiScout.Tab.Mapping.ClustererInitialized == true){
			//console.log("RemoveClusterer2");
			if(MobiScout.Tab.Mapping.clusterLayer) {
				//console.log("RemoveClusterer3");
				MobiScout.Tab.Mapping.clusterLayer.setMap(null);
				//console.log("RemoveClusterer4");
			}
		}
	}
	catch(Err){}
}

MobiScout.Tab.Mapping.SetClusterer = function(){
	if(UseClustering == true){
		try{
			if(MobiScout.Tab.Mapping.ClustererInitialized == false){
				MobiScout.Tab.Mapping.clusterLayer = $('#map_canvas').gmap('get', 'MarkerClusterer');
				if(MobiScout.Tab.Mapping.clusterLayer == undefined || MobiScout.Tab.Mapping.clusterLayer == null){
					MobiScout.Tab.Mapping.clusterLayer = new MarkerClusterer($('#map_canvas').gmap('get', 'map'));
					
					var clusterStyles = [
                              {
                                  textColor: 'black',
                                  url: 'images/clusterer/m1.png',
                                  height: 53,
                                  width: 53
                              },
                             {
                                 textColor: 'black',
                                 url: 'images/clusterer/m2.png',
                                 height: 56,
                                 width: 56
                             },
                             {
                                 textColor: 'black',
                                 url: 'images/clusterer/m3.png',
                                 height: 66,
                                 width: 66
                             },
                             {
                                 textColor: 'black',
                                 url: 'images/clusterer/m4.png',
                                 height: 78,
                                 width: 78
                             },
                             {
                                 textColor: 'black',
                                 url: 'images/clusterer/m5.png',
                                 height: 90,
                                 width: 90
                             }
                            ];
                            MobiScout.Tab.Mapping.clusterLayer.setStyles(clusterStyles);
					
					$('#map_canvas').gmap('set', 'MarkerClusterer', MobiScout.Tab.Mapping.clusterLayer, $('#map_canvas').gmap('get', 'markers'));
				}
				MobiScout.Tab.Mapping.clusterLayer = $('#map_canvas').gmap('get', 'MarkerClusterer');
				MobiScout.Tab.Mapping.clusterLayer.clearMarkers();
				MobiScout.Tab.Mapping.clusterLayer.addMarkers($('#map_canvas').gmap('get', 'markers'));
				MobiScout.Tab.Mapping.ClustererInitialized = true;
			}
			else{
				MobiScout.Tab.Mapping.clusterLayer.setMap($('#map_canvas').gmap('get', 'map'));
				MobiScout.Tab.Mapping.clusterLayer.clearMarkers();
				MobiScout.Tab.Mapping.clusterLayer.addMarkers($('#map_canvas').gmap('get', 'markers'));
			}
		}
		catch(Ex){
			MobiScout.Tab.LogToConsole("SetClusterer: " + Ex);
		}
	}
	else{
		MobiScout.Tab.Mapping.RemoveClusterer();
	}
}
	
MobiScout.Tab.Mapping.RemoveActivityPins = function() {
		try{
		
			$('#map_canvas').gmap('find', 'markers', { }, function(marker) {
				//console.log("found: " + marker.id);
				if ( startsWith( marker.id, "ACT") ) {
					marker.setVisible(false);
					marker.setMap(null);
					marker=null;
				}
   				//if(marker.id == markerId){marker.setVisible(false);}
			});
	 	}
	 	catch(Err){
	 		MobiScout.Tab.LogToConsole("RemoveActivityPins2: "+ Err);
	 	}
	 	
	};
	
MobiScout.Tab.Mapping.FinishPlotVehicleRouteOnMap = function(vehicleid){

		 var lineSymbol = { path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW };

		if(MobiScout.Tab.Mapping.plotArray.length > 0){
			var polyline = $('#map_canvas').gmap('addShape', 'Polyline', { 
	    		'strokeColor': "#0000FF", 
	    		'strokeWeight': 3, 
	    		'icons': [{	icon: lineSymbol, offset: '100%', repeat: '50px' }],
	    		'path': MobiScout.Tab.Mapping.plotArray,
	    		'bounds': true
	  		});
	  		
	  		
	  		try{
		  		//var arrayOfPolygons = $('#map_canvas').gmap('get', 'overlays > Polyline');
	    		for (var i = 0; i < MobiScout.Tab.Mapping.actArray.length; i++) //loop de activiteiten na
	    		{
	        		//var pos = new google.maps.LatLng(MobiScout.Tab.Mapping.actArray[i].Latitude, MobiScout.Tab.Mapping.actArray[i].Longitude);
	        		//var marker = new google.maps.Marker({position: pos, map: $('#map_canvas').gmap('getmap')});
	        		//arrayOfPolygons[0].getPath().push(marker.getPosition());
	        		var color = MobiScout.Tab.App.toRGB(MobiScout.Tab.App.getActivityColor(MobiScout.Tab.Mapping.actArray[i].ActivityID));
	        		
	        		$('#map_canvas').gmap('addShape', 'Circle', { 'strokeColor': "black", 'strokeOpacity': 0.9, 'strokeWeight': 2, 'fillColor': color, 'fillOpacity': 0.3, 'center': new google.maps.LatLng(MobiScout.Tab.Mapping.actArray[i].Latitude, MobiScout.Tab.Mapping.actArray[i].Longitude), 'radius': 20 });
					
					// dit werkt mooi, maar traag en hoe krijgen we ze weer weg?
					//var htmlMarker = new MobiScout.Tab.Mapping.HTMLMarker(MobiScout.Tab.Mapping.actArray[i].Latitude, MobiScout.Tab.Mapping.actArray[i].Longitude);
    				//htmlMarker.setMap($('#map_canvas').gmap('get', 'map'));
    					        		
	        		//MobiScout.Tab.Mapping.AddTemporaryPin("ACT" + i, MobiScout.Tab.Mapping.actArray[i].Latitude, MobiScout.Tab.Mapping.actArray[i].Longitude, MobiScout.Tab.Mapping.actArray[i].ActivityDescr + "(" + MobiScout.Tab.Mapping.actArray[i].ActivityID + ")" );
	        		
	    		}
	  		}
	  		catch(Err){
	  			MobiScout.Tab.LogToConsole("FinishPlotVehicleRouteOnMap: " + Err);
	  		}
	  		// indien we al op de kaart zitten ... automatisch doen
	  		if ($('.ui-page-active').attr('id') == 'map') {
	  			setTimeout("MobiScout.Tab.Mapping.SetPlotBounds()", 500);
	  		}
	  		else{
		  		MobiScout.Tab.App.PlotRouteAfterPageChange = true;
		  		MobiScout.Tab.ChangePage("map");
	  		}
  		}
  		else{
  			// niet gevonden
  			MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.GeenRouteGevonden);
  		}
	};
	
MobiScout.Tab.Mapping.ShowVehicleOnMap = function(id){
		MobiScout.Tab.App.NavigatingToMap = true;
		MobiScout.Tab.Mapping.CenterOnVehicleID(id);
	}


MobiScout.Tab.Mapping.ShowMessageOnMap = function(msgsn){
		MobiScout.Tab.PlayTick();
		// bekijk of we het bericht hebben in MobiScout.Tab.App.Messages of in MobiScout.Tab.App.MessageDialog
		for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
			if(MobiScout.Tab.App.MessageDialog[i].MsgSN == msgsn){
				if(MobiScout.Tab.App.MessageDialog[i].Latitude != 0 && MobiScout.Tab.App.MessageDialog[i].Longitude != 0){
					MobiScout.Tab.Mapping.CenterOnMessage(MobiScout.Tab.App.MessageDialog[i].Latitude, MobiScout.Tab.App.MessageDialog[i].Longitude, MobiScout.Tab.GetMessageDetails(MobiScout.Tab.App.MessageDialog[i]) );
					return;
				}
			}
		}
		for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
			if(MobiScout.Tab.App.Messages[i].MsgSN == msgsn){
				if(MobiScout.Tab.App.Messages[i].Latitude != 0 && MobiScout.Tab.App.Messages[i].Longitude != 0){
					MobiScout.Tab.Mapping.CenterOnMessage(MobiScout.Tab.App.Messages[i].Latitude, MobiScout.Tab.App.Messages[i].Longitude, MobiScout.Tab.GetMessageDetails(MobiScout.Tab.App.Messages[i]));
					return;
				}
			}
		}
	};
	
MobiScout.Tab.Mapping.CenterOnVehicleID = function(vehicleid){
	//console.log("MobiScout.Tab.Mapping.CenterOnVehicleID: " + vehicleid);
	if(MobiScout.Tab.Mapping.VisibleDepartmentID != -1){
		MobiScout.Tab.Mapping.VisibleDepartmentID = -1;
		MobiScout.Tab.Mapping.CheckAllMarkersVisibility();
	}
	
	for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
     	if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
     		MobiScout.Tab.Mapping.CenterOnVehicle(MobiScout.Tab.App.TrackAndTraceList[i].ID, MobiScout.Tab.App.TrackAndTraceList[i].Plate,MobiScout.Tab.App.TrackAndTraceList[i].Latitude, MobiScout.Tab.App.TrackAndTraceList[i].Longitude, MobiScout.Tab.App.TrackAndTraceList[i].Name, MobiScout.Tab.App.TrackAndTraceList[i].ActivityDescription); 
     		break;
        }
    }
};

MobiScout.Tab.Mapping.InitializeMapOnNetherlands = function(){
	try{
		//console.log("MobiScout.Tab.Mapping.InitializeMapOnNetherlands");
		$('#map_canvas').gmap('option', 'zoom', 7);
		var poslatlng = new google.maps.LatLng(52.0, 5.3);
		$('#map_canvas').gmap('setcenter', poslatlng );
		MobiScout.Tab.Mapping.ResizeMap();
		MobiScout.Tab.App.MapCentered = true;
	}
	catch(Err){
	}
}

MobiScout.Tab.Mapping.RemoveTrafficLayer = function(){
	if(MobiScout.Tab.Mapping.TrafficInitialized == true){
		try{
			MobiScout.Tab.Mapping.trafficLayer.setMap(null);
		}
		catch(Err){
		}
	}
}


MobiScout.Tab.Mapping.InitializeTraffic = function(){
	if(MobiScout.Tab.Mapping.TrafficInitialized == false){
		try{
			MobiScout.Tab.Mapping.trafficLayer = new google.maps.TrafficLayer();
		  	MobiScout.Tab.Mapping.trafficLayer.setMap($('#map_canvas').gmap('get', 'map'));
		  	MobiScout.Tab.Mapping.TrafficInitialized = true;
	  	}
	  	catch(Err){
	  	}
  	}
  	else{
  		MobiScout.Tab.Mapping.trafficLayer.setMap($('#map_canvas').gmap('get', 'map'));
  	}
}

MobiScout.Tab.Mapping.CenterOnVehicle = function(vehicleid, plate, latitude, longitude, drivername, activity){
	//	console.log("MobiScout.Tab.Mapping.CenterOnVehicle: " + vehicleid + " " + plate + " " + latitude + " " + longitude);
	 MobiScout.Tab.App.MapCentered = true;
	 try{
	 	MobiScout.Tab.App.CenterMapOnVehicle = true;
	 	MobiScout.Tab.App.CenterMapOnVehiclePosition = new google.maps.LatLng(latitude, longitude);
	 	MobiScout.Tab.ChangePage("map");
	 	/*
	 	setTimeout(function(){
			 $('#map_canvas').gmap('option', 'zoom', 12);
		     var poslatlng = new google.maps.LatLng(latitude, longitude);
		     $('#map_canvas').gmap('setcenter', poslatlng );
	     }, 1000);*/
	     
     }
     catch(Err){
     	console.log("failed to CenterOnVehicle: " + Err);
     }
};

MobiScout.Tab.Mapping.CenterOnMessage = function(latitude, longitude, content){
	 MobiScout.Tab.App.MapCentered = true;
	 try{
	 	MobiScout.Tab.App.NavigatingToMap = true;
	 	MobiScout.Tab.LogToConsole("MobiScout.Tab.Mapping.CenterOnMessage " + latitude + " " + longitude);
		 $('#map_canvas').gmap('option', 'zoom', 12);
	     // pinnetje van maken
	     MobiScout.Tab.Mapping.setTemporaryPosition(latitude, longitude, content);
	     var poslatlng = new google.maps.LatLng(latitude, longitude);
	     $('#map_canvas').gmap('setcenter', poslatlng );
	     MobiScout.Tab.ChangePage("map");
     }
     catch(Err){
     }
};
	
	MobiScout.Tab.Mapping.GenerateInfoWindowContent = function(pinname, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location){
		var retval = '';
		var htmlColor = MobiScout.Tab.App.toRGB(color);
		retval = '<div style="line-height: 0.3em;" id="msinfowin' + pinname + '"><p><strong>' + plate + ' ' + drivername + '</strong></p>';
		if(trailerplate != "" && trailerplate != undefined) retval += '<p>oplegger ' + trailerplate + '</p>';
		retval += '<hr>';
		retval += '<p style="color: gray;white-space:normal;"><img src="images/accessories-clock.png" width="12" height="12"/>&nbsp;&nbsp;' + tsstatus + '</p>';
		retval += '<div><div style="float: left; margin-top: -0px; background-color: ' + htmlColor + ';width:12px;height:12px;-moz-border-radius: 6px/6px;-webkit-border-radius: 6px 6px;border-radius: 6px/6px;"></div><p style="color: gray;font-weight: normal; overflow: hidden;line-height: 1.0em;" >&nbsp;&nbsp;' + activity + '</p></div>';
		//retval += '<p style="color: gray" ><strong>' + activity + '</strong></p>';
		if(!isBlank(location)){
			if(startsWith(location, "POI:")){
				retval += '<p style="color: gray;white-space:normal;font-size:10px; overflow: hidden;line-height: 1.0em;"><img src="images/flag_green.png" width="12" height="12"/><strong>&nbsp;&nbsp;' + location.substring(4, location.length).trim() + '</strong></p>';
			}
			else if(startsWith(location, "ADR:")){
				retval += '<p style="color: gray;white-space:normal;font-size:10px; overflow: hidden;line-height: 1.0em;"><img src="images/user.png" width="12" height="12"/><strong>&nbsp;&nbsp;' + location.substring(4, location.length).trim() + '</strong></p>';
			}
			else if(startsWith(location, "POLY:")){
				retval += '<p style="color: gray;white-space:normal;font-size:10px; overflow: hidden;line-height: 1.0em;"><img src="images/flag_red.png" width="12" height="12"/><strong>&nbsp;&nbsp;' + location.substring(5, location.length).trim() + '</strong></p>';
			}
			else{
				retval += '<p style="color: gray;white-space:normal;font-size:10px; overflow: hidden;line-height: 1.0em;" >' + location.trim() + '</p>';
			}
		}
		try{
			var addInfo = '';
			if(expectedduration > 0 && !isBlank(destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(expectedduration) + "&nbsp;en&nbsp;" + destination;
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(expectedduration) + "&nbsp;en&nbsp;" + destination;
	        }
	        else if(expectedduration > 0)
	        {
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(expectedduration);
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(expectedduration);
	        }
	        else if(!isBlank(destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = destination;
	        	else addInfo += "<br>" + destination;
	        }		
	        if(!isBlank(addInfo)) retval += '<p style="color: gray;white-space:normal; overflow: hidden;line-height: 1.0em;">' + addInfo + '</p>';
	    }
	    catch(err){
	    }
	    // add new message icon + call vehicle icon
	    retval += '<div class="li-hor-menu-map">';
		retval += '<img class="InlineMenuImage" src="images/blackwhite/Message_Outline.png" onclick="MobiScout.Tab.UI.Vehicle.SendNewMessage(this, ' + pinname + ')"/>';
		if(authorisationForRoute == true) retval += '<img class="InlineMenuImage" src="images/blackwhite/Polyline.png" onclick="MobiScout.Tab.UI.Vehicle.LoadRoute(this, ' + pinname + ', true)"/>';
		retval += '<img class="InlineMenuImage" src="images/blackwhite/Phone-Open.png" onclick="MobiScout.Tab.UI.Vehicle.CallVehicle(this, ' + pinname + ')"/>';
		retval += '<img class="InlineMenuImage" src="images/blackwhite/Define_Location.png" onclick="MobiScout.Tab.UI.Vehicle.SendPositionRequest(this, ' + pinname + ')">&nbsp;</img>';
		
		
		retval += '</div>';
		
		retval += '</div>';
		return retval;
	}
	
	MobiScout.Tab.Mapping.GenerateVehicleIcon = function(pinname, latitude, longitude, image, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location){
		var htmlColor = MobiScout.Tab.App.toRGB(color);
		var colorSymbol = {
               //path: google.maps.SymbolPath.CIRCLE,
               path: 'M 2,6 3,5 14,5 14,18 2,18 z M 16,2 62,2 62,18 16,18 z M 12 18 a 4 4 0 1 0 0.00001 0 z  M 50 18 a 4 4 0 1 0 0.00001 0 z',
               scale: 1.0,
              /* animation: google.maps.Animation.DROP,*/
               fillOpacity: 0.75,
               fillColor: htmlColor,
               title: MobiScout.Tab.Mapping.GenerateInfoWindowContent(pinname, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location),
               strokeColor: '#FF0000'
           };
        return colorSymbol;
	};

	MobiScout.Tab.Mapping.GenerateVehicleColorOverlay = function(color){
		var htmlColor = MobiScout.Tab.App.toRGB(color);
		var colorSymbol = {
               path: 'M 9,0 33,0 33,11 9,11 z',
               scale: 1.0,
               fillOpacity: 0.75,
               fillColor: htmlColor,
               strokeColor: '#FF000000'
           };
        return colorSymbol;
	};

	MobiScout.Tab.Mapping.RemovePin = function(pinname) {
		try{
			var markers = $('#map_canvas').gmap('get', 'markers');
	        if (markers) {
		        if (markers[pinname]) {
		        	markers[pinname].setVisible(false);
		        }
		        /*if(UseServerImages == false){
					if (markers[pinname + "_color"]) {
			        	markers[pinname + "_color"].setVisible(false);
			        }
		        }*/
		        
		 	}
	 	}
	 	catch(Err){
	 	}
	 	
	};

	MobiScout.Tab.Mapping.AddNewPin = function (pinname, latitude, longitude, image, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location) {
    	try{
        	if (!isNaN(latitude) && !isNaN(longitude)) {
				if(UseServerImages == true){
					try{
						var strURL = WebServiceURL + webServicePage + "/getMapIcon?vehicleID=" + pinname + "&plate=" + plate + "&trailerplate=" + trailerplate + "&color=" + color;
						if(showVehiclePlate == false) strURL = WebServiceURL + webServicePage + "/getMapIcon?vehicleID=" + pinname + "&plate=" + pinname + "&trailerplate=" + trailerplate + "&color=" + color;
	           			var iconImage = {url: strURL ,anchor: new google.maps.Point(0,0)};
	          	 		$('#map_canvas').gmap('addMarker', { 
		               		'id': pinname,
							'icon': iconImage, 
							'position': latitude + ',' + longitude,
							'bounds': true,
							'zIndex': 1,
							'content': MobiScout.Tab.Mapping.GenerateInfoWindowContent(pinname, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location)
							}).click(function () {
								MobiScout.Tab.PlayTick();
	                   			$('#map_canvas').gmap('openInfoWindow', { 'content': $(this)[0].content }, this);
	                   			$('#map_canvas').gmap('panto', $(this)[0].getPosition() );
	               			});
	            	}
	            	catch(Err1){
	            		MobiScout.Tab.LogToConsole("Err adding icon: " + Err1);
	            	}
	        	}
	        	else{           
	           		try{
	           			var iconImage = {url: image ,anchor: new google.maps.Point(0,0)};
	          	 		$('#map_canvas').gmap('addMarker', { 
		               		'id': pinname,
							'icon': /*image */ iconImage, 
							'position': latitude + ',' + longitude,
							'bounds': true,
							'zIndex': 1, 
							'content': MobiScout.Tab.Mapping.GenerateInfoWindowContent(pinname, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location)
							}).click(function () {
								MobiScout.Tab.PlayTick();
	                   			$('#map_canvas').gmap('openInfoWindow', { 'content': $(this)[0].content }, this);
	                   			$('#map_canvas').gmap('panto', $(this)[0].getPosition() );
	               			});
	            	}
	            	catch(Err1){
	            		MobiScout.Tab.LogToConsole("Err adding icon: " + Err1);
	            	}
	            
	            	try{
	            		// kleur overlay op dezelfde locatie toevoegen
						/*$('#map_canvas').gmap('addMarker', { 
			               		'id': pinname + "_color",
								'icon': MobiScout.Tab.Mapping.GenerateVehicleColorOverlay(color), 
								'position': latitude + ',' + longitude,
								'zIndex': 2,
								'bounds': true, 
								'content': MobiScout.Tab.Mapping.GenerateInfoWindowContent(pinname, color, plate, drivername, activity, tsstatus, trailerplate, expectedduration, destination, location)
								}).click(function () {
									MobiScout.Tab.PlayTick();
		                   			$('#map_canvas').gmap('openInfoWindow', { 'content': $(this)[0].content }, this);
		                   			$('#map_canvas').gmap('panto', $(this)[0].getPosition() );
		               			});*/               			
					               			
	           		}
	           		catch(Err2){
	          	 		MobiScout.Tab.LogToConsole("Err adding color overlay: " + Err2);
	           		}
	           	}
           	}
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Mapping.AddNewPin: " + Err);
        }
    };
    
    MobiScout.Tab.Mapping.CheckAllMarkersVisibility = function(){
    	try{
	    	$('#map_canvas').gmap('find', 'markers',  {  }, function(marker) {
	    		if(MobiScout.Tab.Mapping.VisibleDepartmentID >= 0){
					try{                    	
						var id = Number(marker.id);
						if(MobiScout.Tab.App.getDepartmentForVehicle(id) == MobiScout.Tab.Mapping.VisibleDepartmentID)
						{
							marker.setVisible(true);
						}
						else{
							marker.setVisible(false);
						}
					}
					catch(Err){
						marker.setVisible(true);
					}
				}
				else{
					marker.setVisible(true);
				}
	    	})
    	}
    	catch(Err){}
    }
    
    
    MobiScout.Tab.Mapping.AddTemporaryPin = function (pinname, latitude, longitude, content) {
       try{
   			//console.log("AddTemporaryPin: " + pinname);
           if (!isNaN(latitude) && !isNaN(longitude)) {
               $('#map_canvas').gmap('addMarker', { 
	               		'id': pinname,
						'position': +latitude + ',' + longitude,
						'bounds': true, 
						'content': content
						}).click(function () {
							MobiScout.Tab.PlayTick();
                   			$('#map_canvas').gmap('openInfoWindow', { 'content': $(this)[0].content }, this);
                   			$('#map_canvas').gmap('panto', $(this)[0].getPosition() );
               			});
           }
        }
        catch(Err){}
    };
    
    MobiScout.Tab.Mapping.checkGeofenceDisplay = function(){
    	// als de geofences aan moeten, dan displayen we ze 1 voor 1 op de kaart
    	for (var i=0; i<MobiScout.Tab.App.Geofences.length; i++) {
    		if(MobiScout.Tab.App.Geofences[i].RadiusEnter > 0){
    			MobiScout.Tab.Mapping.addGeofenceOnMap(MobiScout.Tab.App.Geofences[i].Latitude, MobiScout.Tab.App.Geofences[i].Longitude, MobiScout.Tab.App.Geofences[i].RadiusEnter);
    		}
    	}
    }
    
    MobiScout.Tab.Mapping.addGeofenceOnMap = function(latitude, longitude, radius){
    	if(checkGoogleMapsPresence()){
    	var geofencePosition = new google.maps.LatLng(latitude, longitude);
	    	$('#map_canvas').gmap('addShape', 'Circle', { 
					'strokeWeight': 0, 
					'fillColor': "#008595", 
					'fillOpacity': 0.25, 
					'center': geofencePosition, 
					'radius': radius, 
					'clickable': false 
				});
		}
    }
    
    MobiScout.Tab.Mapping.SearchForLocation = function (searchText){
    	try{
	    	$('#map_canvas').gmap('search', { 'address': searchText }, function(results,isFound) {
	    		if (isFound){
	        		$('#map_canvas').gmap('panto', results[0].geometry.location);
	        		$('#map_canvas').gmap('option', 'zoom', 12);
	        		//$('#map_canvas').gmap('refresh');
	        		MobiScout.Tab.Mapping.ResizeMap();
	        	}
			});
		}
		catch(Err){
			MobiScout.Tab.LogToConsole("MobiScout.Tab.Mapping.SearchForLocation failed: "+ searchText);
		}
    }
    
    MobiScout.Tab.Mapping.clearTemporaryPosition = function(){
    	MobiScout.Tab.Mapping.RemovePin('temp');
    };
    
    MobiScout.Tab.Mapping.setTemporaryPosition = function(latitude, longitude, content){
    	try {
         	var markers = $('#map_canvas').gmap('get', 'markers');
            if (markers) {
                if (!markers['temp']) {
                    MobiScout.Tab.Mapping.AddTemporaryPin('temp', latitude, longitude, content);
                }
                else {
                    var latlng = new google.maps.LatLng(latitude, longitude);
                    markers['temp'].setPosition(latlng);
                    markers['temp'].content = content;
                    markers['temp'].setVisible(true);
                    var theInfoWindowObject = $('#map_canvas').gmap('get', 'iw');
                    if(theInfoWindowObject){ 
                    	theInfoWindowObject.close();
                    }
                }
            }
        } catch (Err) {
        }
    };
    
    MobiScout.Tab.Mapping.setPosition = function (pinname, latitude, longitude, image, color, plate, drivername, activity, tsstatus, trailerid, expectedduration, destination, location) {
        try {
         	var markers = $('#map_canvas').gmap('get', 'markers');
            if (markers) {
            	var trailerPlate = "";
            	if(trailerid > 0) trailerPlate = MobiScout.Tab.App.GetTrailerPlate(trailerid);
                if (!markers[pinname]) {
                    MobiScout.Tab.Mapping.AddNewPin(pinname, latitude, longitude, image, color, plate, drivername, activity, tsstatus, trailerPlate, expectedduration, destination, location);
                }
                else {
                    var latlng = new google.maps.LatLng(latitude, longitude);
                    markers[pinname].setPosition(latlng);
                    markers[pinname].content = MobiScout.Tab.Mapping.GenerateInfoWindowContent(pinname, color, plate, drivername, activity, tsstatus, trailerPlate, expectedduration, destination, location);
                    
                    
                    // indien we plaatjes van de server halen, hier ook bijwerken
                    if(UseServerImages == true){
                    	// misschien is de activiteit gewijzigd immers
                    	var strURL = WebServiceURL + webServicePage + "/getMapIcon?vehicleID=" + pinname + "&plate=" + plate + "&trailerplate=" + trailerPlate + "&color=" + color;
	           			var iconImage = {url: strURL ,anchor: new google.maps.Point(0,0)};
                    	markers[pinname].setIcon(iconImage);
                    }
                    else{
	                    /*markers[pinname + "_color"].setPosition(latlng);
	                    markers[pinname + "_color"].setVisible(true);*/
                    } 
                    
                    var theInfoWindowObject = $('#map_canvas').gmap('get', 'iw');
                    if(theInfoWindowObject){ 
                    	theInfoWindowObject.close();
                    }
                    
                    
                    
                }
            }
        } catch (Err) {
        }


      
        
    };
    
	MobiScout.Tab.Mapping.ClearPositions = function(){
		try{
			$('#map_canvas').gmap('clear', 'markers');
		}
		catch(Err){}
	};
	