/* todo

- OK sortering van de cao groepen op ID
- OK embedded handleiding bijwerken voor RT uren
- OK timeline.applyRange(start, end, opt zoomAroundDate)
- OK verversen indien het scherm openstaat zodat de eindtijd meeloopt + nieuwe berichten worden verwerkt
- OK groepen zouden de totale tijd moeten weergeven (dus eerst tellen en dan de groepsnamen aanpassen?!)
- OK Detail informatie over geselecteerde activiteit maken (nu alleen MsgSN)
- ook toevoegen in webversie (na testen)
- menu item aanmaken voor RT uren

*/

MobiScout.Tab.UI.RTHours.timeline = null;
MobiScout.Tab.UI.RTHours.MessageList = new Array();
MobiScout.Tab.UI.RTHours.Data;

MobiScout.Tab.UI.RTHours.ShowHoursForVehicle = function(vehicleID, isRefresh){
	//console.log("Show hours for vehicle " + vehicleID);
	$('#rtinfo').html('');
	if(isRefresh == false){
		if(MobiScout.Tab.UI.RTHours.timeline != null){
			MobiScout.Tab.UI.RTHours.timeline.deleteAllItems();
		}
		MobiScout.Tab.UI.RTHours.MessageList.splice(0, MobiScout.Tab.UI.RTHours.MessageList.length);
	}
	MobiScout.Tab.Data.getRealtimeHours(vehicleID, isRefresh); 
	
};

MobiScout.Tab.UI.RTHours.AddMessageToList = function(message, isRefresh){
	if(isBlank(message.CaoGroupDescr)) message.CaoGroupDescr = 'Geen';
	if(isRefresh == true){
		for(var i = 0; i < MobiScout.Tab.UI.RTHours.MessageList.length; i ++){
			if(MobiScout.Tab.UI.RTHours.MessageList[i].MsgSN == message.MsgSN) return;
		}
	}
	MobiScout.Tab.UI.RTHours.MessageList.push(message);
};

MobiScout.Tab.UI.RTHours.UpdateView = function(){
	MobiScout.Tab.UI.RTHours.drawVisualization(); 
};

MobiScout.Tab.UI.RTHours.ClearData = function(){
	MobiScout.Tab.LogToConsole("RTHours.ClearData()");
	if(MobiScout.Tab.UI.RTHours.timeline != null){
			MobiScout.Tab.UI.RTHours.timeline.deleteAllItems();
			delete MobiScout.Tab.UI.RTHours.timeline;
	}
	MobiScout.Tab.UI.RTHours.timeline = null;
	$('#rtinfo').empty();
};

MobiScout.Tab.UI.RTHours.Redraw = function(clearInfo){
	if(MobiScout.Tab.UI.RTHours.timeline != null){
		if(($(document).height() > $(document).width()) && $(document).width() < 800){
		    if(MobiScout.Tab.UI.RTHours.MessageList.length > 0){
		    	MobiScout.Tab.UI.RTHours.timeline.applyRange(new Date(MobiScout.Tab.UI.RTHours.MessageList[0].TimeStamp), MobiScout.Tab.GetCurrentDate());
		    }
	    }
	    else{
	    	var start = MobiScout.Tab.GetCurrentDate();
			start.setHours(0,0,0,0);
			var end = MobiScout.Tab.GetCurrentDate();
			end.setHours(23,59,59,999);
	    	MobiScout.Tab.UI.RTHours.timeline.applyRange(start, end);
	    }
		MobiScout.Tab.UI.RTHours.timeline.redraw();
	}
	if(clearInfo) $('#rtinfo').html(MobiScout.Tab.UI.RTHours.GetTotalsPerCaoGroup());
}

MobiScout.Tab.UI.RTHours.drawVisualization = function() {

	MobiScout.Tab.UI.RTHours.Data = [];
	for (var i = 0; i < MobiScout.Tab.UI.RTHours.MessageList.length; i++) {
		var dateStart = new Date(MobiScout.Tab.UI.RTHours.MessageList[i].TimeStamp);
		var dateStop;
		if(i < MobiScout.Tab.UI.RTHours.MessageList.length -1 ) dateStop = new Date(MobiScout.Tab.UI.RTHours.MessageList[i + 1].TimeStamp);
		else dateStop = MobiScout.Tab.GetCurrentDate();
		var htmlcolor = MobiScout.Tab.App.toRGB(MobiScout.Tab.UI.RTHours.MessageList[i].Color);
		if(!isBlank(MobiScout.Tab.UI.RTHours.MessageList[i].CaoGroupDescr)){
			MobiScout.Tab.UI.RTHours.Data.push({ 'start': dateStart, 'end': dateStop,'content': '<div class="order" style="background-color:' + htmlcolor + ' !important;">' + MobiScout.Tab.UI.RTHours.MessageList[i].ActivityDescr + '</div>','group': MobiScout.Tab.UI.RTHours.MessageList[i].CaoGroupDescr });
		}
	}
	
	if(MobiScout.Tab.UI.RTHours.timeline == null){
		//console.log("set options"); 
	    var options = {
	    	width:  "100%",
	        height: "auto",
	        layout: "box",
	        editable: false,
	        selectable: true,
	        eventMargin: 0,  // minimal margin between events
	        eventMarginAxis: 10, // minimal margin beteen events and the axis
	        showMajorLabels: false,
	        axisOnTop: true,
	        groupsChangeable : false,
	        groupsOnRight: false,
	        groupsOrder: MobiScout.Tab.UI.RTHours.OrderCAOGroups
	    };
		//console.log("instantiate timeline");            
	    MobiScout.Tab.UI.RTHours.timeline = new links.Timeline(document.getElementById('rthours'), options);
	    links.events.addListener(MobiScout.Tab.UI.RTHours.timeline, 'select', MobiScout.Tab.UI.RTHours.ItemSelect);
	}
	
	for(var i = 0; i < MobiScout.Tab.App.CaoTypes.length; i ++){
		if(MobiScout.Tab.App.CaoTypes[i].CaoID > 0){
			MobiScout.Tab.UI.RTHours.timeline.getGroup(MobiScout.Tab.App.CaoTypes[i].Description);
			if(MobiScout.Tab.UI.RTHours.MessageList.length > 0){
			 	// dummy toevoegen zodat alle groepen getoond worden.
				MobiScout.Tab.UI.RTHours.Data.push({ 'start': new Date(MobiScout.Tab.UI.RTHours.MessageList[0].TimeStamp), 'end': new Date(MobiScout.Tab.UI.RTHours.MessageList[0].TimeStamp),'content': '<div class="order" style="background-color:0 !important;">&nbsp;</div>','group': MobiScout.Tab.App.CaoTypes[i].Description });
		    }
			//console.log("added group: " + MobiScout.Tab.App.CaoTypes[i].Description);
		}
	}   
    MobiScout.Tab.UI.RTHours.timeline.draw(MobiScout.Tab.UI.RTHours.Data);
    MobiScout.Tab.UI.RTHours.Redraw(true);
};

MobiScout.Tab.UI.RTHours.OrderCAOGroups = function(a, b){
	if(MobiScout.Tab.App.GetCaoIDForGroupName(a.content) > MobiScout.Tab.App.GetCaoIDForGroupName(b.content)) return 1;
	return 0; 
}

MobiScout.Tab.UI.RTHours.getSelectedRow = function() {
	var row = undefined;
	if(MobiScout.Tab.UI.RTHours.timeline != null){
	    var sel = MobiScout.Tab.UI.RTHours.timeline.getSelection();
	    if (sel.length) {
	    	if (sel[0].row != undefined) {
	        	row = sel[0].row;
	        }
	   	}
   	}
   	return row;
};

MobiScout.Tab.UI.RTHours.GetDurationForMessage = function(i){
	var dateStart = new Date(MobiScout.Tab.UI.RTHours.MessageList[i].TimeStamp);
	var dateStop;
	if(i < MobiScout.Tab.UI.RTHours.MessageList.length -1 ) dateStop = new Date(MobiScout.Tab.UI.RTHours.MessageList[i + 1].TimeStamp);
	else dateStop = MobiScout.Tab.GetCurrentDate();
	var msdiffminutes = (dateStop.getTime() - dateStart.getTime()) / 60000;
	msdiffminutes = Math.round(msdiffminutes);
	if(i == MobiScout.Tab.UI.RTHours.MessageList.length -1 ){
		return MobiScout.Tab.ConvertMinutesToTimeSpan(msdiffminutes) + '&nbsp;&nbsp;<img src="images/spinner.gif" width="16" height="16"/>';
	}
	return MobiScout.Tab.ConvertMinutesToTimeSpan(msdiffminutes);
}

MobiScout.Tab.UI.RTHours.GetMSDurationForMessage = function(i){
	var dateStart = new Date(MobiScout.Tab.UI.RTHours.MessageList[i].TimeStamp);
	var dateStop;
	if(i < MobiScout.Tab.UI.RTHours.MessageList.length -1 ) dateStop = new Date(MobiScout.Tab.UI.RTHours.MessageList[i + 1].TimeStamp);
	else dateStop = MobiScout.Tab.GetCurrentDate();
	return dateStop.getTime() - dateStart.getTime();
}


MobiScout.Tab.UI.RTHours.GetTotalTimeForGroup = function(caoid){
	var totalmilliseconds = 0
	for(var i = 0; i < MobiScout.Tab.UI.RTHours.MessageList.length; i ++){
		if(MobiScout.Tab.UI.RTHours.MessageList[i].CaoGroupID == caoid){
			totalmilliseconds += MobiScout.Tab.UI.RTHours.GetMSDurationForMessage(i);
		}
	}
	totalmilliseconds /= 60000; // naar minuten
	totalmilliseconds = Math.round(totalmilliseconds);
	
	return MobiScout.Tab.ConvertMinutesToTimeSpan(totalmilliseconds);
}

MobiScout.Tab.UI.RTHours.GetTotalsPerCaoGroup = function(){
	var retval = '<table style="font-size: 12px;border-collapse: collapse;border-spacing: 0;font: bold  12px arial ;color: #103E9C;">';
	retval += '<tr><td></td><td></td></tr>';
	for(var i = 0; i < MobiScout.Tab.App.CaoTypes.length; i ++){
		if(MobiScout.Tab.App.CaoTypes[i].CaoID > 0){
				retval += '<tr>';
				retval += '<td style="padding-left: 10px;padding-right: 10px;padding-top:5px;">' + MobiScout.Tab.App.CaoTypes[i].Description + '</td>';
				retval += '<td style="padding-left: 10px;padding-right: 10px;padding-top:5px;">' + MobiScout.Tab.UI.RTHours.GetTotalTimeForGroup(MobiScout.Tab.App.CaoTypes[i].CaoID) + '</td>';
				retval += '</tr>';
		}
	}
	retval += '</table>';
	return retval;
}

MobiScout.Tab.UI.RTHours.ItemSelect = function (event) {
	MobiScout.Tab.PlayTick();
	var row = MobiScout.Tab.UI.RTHours.getSelectedRow();
	if (row != undefined) {
		
		
	    var duration = MobiScout.Tab.UI.RTHours.GetDurationForMessage(row);
	    // TODO: de duur moet hier nog bij
	    // op basis van het statusbericht nog even proberen te tonen welke zendingen het over gaat enzo
	    var messageinfo = MobiScout.Tab.UI.FormatMessageForDisplay(MobiScout.Tab.UI.RTHours.MessageList[row], duration);
	    $('#rtinfo').html('<br>' + messageinfo);
	    if(MobiScout.Tab.UI.RTHours.MessageList[row].StopSN > 0 && authorisationForTrips == true){
		    // get stop details
			MobiScout.Tab.App.CurrentMessageStopSN = MobiScout.Tab.UI.RTHours.MessageList[row].StopSN; 
		    MobiScout.Tab.Data.GetDetailsForStop(MobiScout.Tab.UI.RTHours.MessageList[row].StopSN);
		}
    }
	else {
    	//document.getElementById("info").innerHTML += "no item selected<br>";
    	$('#rtinfo').html(MobiScout.Tab.UI.RTHours.GetTotalsPerCaoGroup());
    }
};
