var Base64 = {

    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
            this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

/*


MobiScout.Tab.distVincenty = function(lat1, lon1, lat2, lon2) {
    var a = 6378137, b = 6356752.314245, f = 1 / 298.257223563;  // WGS-84 ellipsoid params
    var L = (lon2 - lon1).toRad();
    var U1 = Math.atan((1 - f) * Math.tan(lat1.toRad()));
    var U2 = Math.atan((1 - f) * Math.tan(lat2.toRad()));
    var sinU1 = Math.sin(U1), cosU1 = Math.cos(U1);
    var sinU2 = Math.sin(U2), cosU2 = Math.cos(U2);

    var lambda = L, lambdaP, iterLimit = 100;
    do {
        var sinLambda = Math.sin(lambda), cosLambda = Math.cos(lambda);
        var sinSigma = Math.sqrt((cosU2 * sinLambda) * (cosU2 * sinLambda) +
      (cosU1 * sinU2 - sinU1 * cosU2 * cosLambda) * (cosU1 * sinU2 - sinU1 * cosU2 * cosLambda));
        if (sinSigma == 0) return 0;  // co-incident points
        var cosSigma = sinU1 * sinU2 + cosU1 * cosU2 * cosLambda;
        var sigma = Math.atan2(sinSigma, cosSigma);
        var sinAlpha = cosU1 * cosU2 * sinLambda / sinSigma;
        var cosSqAlpha = 1 - sinAlpha * sinAlpha;
        var cos2SigmaM = cosSigma - 2 * sinU1 * sinU2 / cosSqAlpha;
        if (isNaN(cos2SigmaM)) cos2SigmaM = 0;  // equatorial line: cosSqAlpha=0 (6)
        var C = f / 16 * cosSqAlpha * (4 + f * (4 - 3 * cosSqAlpha));
        lambdaP = lambda;
        lambda = L + (1 - C) * f * sinAlpha *
      (sigma + C * sinSigma * (cos2SigmaM + C * cosSigma * (-1 + 2 * cos2SigmaM * cos2SigmaM)));
    } while (Math.abs(lambda - lambdaP) > 1e-12 && --iterLimit > 0);

    if (iterLimit == 0) return NaN  // formula failed to converge

    var uSq = cosSqAlpha * (a * a - b * b) / (b * b);
    var A = 1 + uSq / 16384 * (4096 + uSq * (-768 + uSq * (320 - 175 * uSq)));
    var B = uSq / 1024 * (256 + uSq * (-128 + uSq * (74 - 47 * uSq)));
    var deltaSigma = B * sinSigma * (cos2SigmaM + B / 4 * (cosSigma * (-1 + 2 * cos2SigmaM * cos2SigmaM) -
    B / 6 * cos2SigmaM * (-3 + 4 * sinSigma * sinSigma) * (-3 + 4 * cos2SigmaM * cos2SigmaM)));
    var s = b * A * (sigma - deltaSigma);

    s = s.toFixed(3); // round to 1mm precision
    return s;

    // note: to return initial/final bearings in addition to distance, use something like:
    var fwdAz = Math.atan2(cosU2 * sinLambda, cosU1 * sinU2 - sinU1 * cosU2 * cosLambda);
    var revAz = Math.atan2(cosU1 * sinLambda, -sinU1 * cosU2 + cosU1 * sinU2 * cosLambda);
    return { distance: s, initialBearing: fwdAz.toDeg(), finalBearing: revAz.toDeg() };
}*/

function isBlank(str) {
    return (!str || /^\s*$/.test(str));
}

startsWith = function (instr, str) {
    //return (instr.match("^" + str) == str)
    if (instr.lastIndexOf(str, 0) === 0) return true;
    return false;
};

endsWith = function(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
}
/*Date.prototype.getNameOfDay =
  function(utc) {
    var d = this.getISODay(utc) - 1;
    return Date.nameOfDays[d];
  };

// Return the name of the month
Date.prototype.getNameOfMonth =
  function(utc) {
    var m = utc ? this.getUTCMonth() : this.getMonth();
    return Date.nameOfMonths[m];
  };*/
// Format a date according to a specified format
Date.prototype.format =
  function (s, utc) {
      // Split into array
      s = s.split('');
      var l = s.length;
      var r = '';
      var n = m = null;


      for (var i = 0; i < l; i++) {
          switch (s[i]) {
              // Day of the month, 2 digits with leading zeros: 01 to 31   
              case 'd':
                  n = utc ? this.getUTCDate() : this.getDate();
                  if (n * 1 < 10)
                      r += '0';
                  r += n;
                  break;
              // A textual representation of a day, three letters:  Mon through Sun    
              case 'D':
                  r += this.getNameOfDay(utc).substring(0, 3);
                  break;
              // Day of the month without leading zeros:   1 to 31   
              case 'j':
                  r += utc ? this.getUTCDate() : this.getDate();
                  break;
              // Lowercase l A full textual representation of the day of the week: Sunday (0) through Saturday (6)    
              case 'l':
                  r += this.getNameOfDay(utc);
                  break;
              // ISO-8601 numeric representation of the day of the week: 1 (for Monday) through 7 (for Sunday)    
              case 'N':
                  r += this.getISODay(utc);
                  break;
              // English ordinal suffix for the day of the month, 2 characters   
              case 'S':
                  r += this.getDaySuffix(utc);
                  break;
              // Numeric representation of the day of the week: 0 (for Sunday) through 6 (for Saturday)    
              case 'w':
                  r += utc ? this.getUTCDay() : this.getDay();
                  break;
              // The day of the year (starting from 0) 0 through 365   
              case 'z':
                  n = 0;
                  m = utc ? this.getUTCMonth() : this.getMonth();
                  for (var i = 0; i < m; i++)
                      n += Date.daysInMonth[i]
                  if (this.isLeapYear())
                      n++;
                  n += utc ? this.getUTCDate() : this.getDate();
                  n--;
                  r += n;
                  break;
              //   break;   
              // ISO-8601 week number of year, weeks starting on Monday   
              case 'W':
                  r += this.getISOWeek(utc);
                  break;
              // A full textual representation of a month, such as January or March:  January through December    
              case 'F':
                  r += this.getNameOfMonth(utc);
                  break;
              // Numeric representation of a month, with leading zeros 01 through 12    
              case 'm':
                  n = utc ? this.getUTCMonth() : this.getMonth();
                  n++;
                  if (n < 10)
                      r += '0';
                  r += n;
                  break;
              // A short textual representation of a month, three letters:  Jan through Dec    
              case 'M':
                  r += this.getNameOfMonth(utc).substring(0, 3);
                  break;
              // Numeric representation of a month, without leading zeros:  1 through 12    
              case 'n':
                  n = utc ? this.getUTCMonth() : this.getMonth();
                  r += ++n;
                  break;
              // Number of days in the given month: 28 through 31    
              case 't':
                  r += this.getDaysInMonth(utc);
                  break;
              // Whether it's a leap year:  1 if it is a leap year, 0 otherwise.   
              case 'L':
                  if (this.isLeapYear(utc))
                      r += '1';
                  else
                      r += '0';
                  break;
              // ISO-8601 year number. This has the same value as Y, except that if the ISO week number (W) belongs to the previous or next year, that year is used instead   
              /*
              case 'o':
              break;
              */ 
              // A full numeric representation of a year, 4 digits   
              case 'Y':
                  r += utc ? this.getUTCFullYear() : this.getFullYear();
                  break;
              // A two digit representation of a year   
              case 'y':
                  n = utc ? this.getUTCFullYear() : this.getFullYear();
                  r += (n + '').substring(2);
                  break;
              // Lowercase Ante meridiem and Post meridiem am or pm    
              case 'a':
                  n = utc ? this.getUTCHours() : this.getHours();
                  r += n < 12 ? 'am' : 'pm';
                  break;
              // Uppercase Ante meridiem and Post meridiem AM or PM    
              case 'A':
                  n = utc ? this.getUTCHours() : this.getHours();
                  r += n < 12 ? 'AM' : 'PM';
                  break;
              // Swatch Internet time 000 through 999    
              // case 'B':   
              //   break;   
              // 12-hour format of an hour without leading zeros   
              case 'g':
                  n = utc ? this.getUTCHours() : this.getHours();
                  if (n > 12)
                      n -= 12;
                  r += n;
                  break;
              // 24-hour format of an hour without leading zeros 0 through 23   
              case 'G':
                  r += this.getHours();
                  break;
              //  12-hour format of an hour with leading zeros 01 through 12    
              case 'h':
                  n = utc ? this.getUTCHours() : this.getHours();
                  if (n > 12)
                      n -= 12;
                  if (n < 10)
                      r += '0';
                  r += n;
                  break;
              // 24-hour format of an hour with leading zeros 00 through 23    
              case 'H':
                  n = utc ? this.getUTCHours() : this.getHours();
                  if (n < 10)
                      r += '0';
                  r += n;
                  break;
              // i Minutes with leading zeros 00 to 59    
              case 'i':
                  n = utc ? this.getUTCMinutes() : this.getMinutes();
                  if (n < 10)
                      r += '0';
                  r += n;
                  break;
              // s Seconds, with leading zeros 00 through 59    
              case 's':
                  n = utc ? this.getUTCSeconds() : this.getSeconds();
                  if (n < 10)
                      r += '0';
                  r += n;
                  break;
              // Milliseconds   
              case 'u':
                  r += utc ? this.getUTCMilliseconds() : this.getMilliseconds();
                  break;
              // Timezone identifier   
              // case 'e':   
              //   break;   
              // Whether or not the date is in daylight saving time 1 if Daylight Saving Time, 0 otherwise.    
              case 'I':
                  if (this.getMinutes() != this.getUTCMinutes)
                      r += '1';
                  else
                      r += '0';
                  break;
              // Difference to Greenwich time (GMT) in hours   
              case 'O':
                  n = this.getTimezoneOffset() / 60;
                  if (n >= 0)
                      r += '+';
                  else
                      r += '-';
                  n = Math.abs(n);
                  if (Math.abs(n) < 10)
                      r += '0';
                  r += n + '00';
                  break;
              // Difference to Greenwich time (GMT) with colon between hours and minutes: Example: +02:00    
              case 'P':
                  n = this.getTimezoneOffset() / 60;
                  if (n >= 0)
                      r += '+';
                  else
                      r += '-';
                  n = Math.abs(n);
                  if (Math.abs(n) < 10)
                      r += '0';
                  r += n + ':00';
                  break;
              // T Timezone abbreviation EST, MDT etc.    
              // case 'T':   
              //   break;   
              // Z Timezone offset in seconds. The offset for timezones west of UTC is always negative, and for those east of UTC is always positive.    
              case 'Z':
                  r += this.getTimezoneOffset() * 60;
                  break;
              // ISO 8601 date: 2004-02-12T15:19:21+00:00    
              case 'c':
                  r += this.format('Y-m-d', utc) + 'T' + this.format('H:i:sP', utc);
                  break;
              // RFC 2822 formatted date Example: Thu, 21 Dec 2000 16:01:07 +0200    
              case 'r':
                  r += this.format('D, j M Y H:i:s P', utc);
                  break;
              case 'U':
                  r += this.getTime();
                  break;
              default:
                  r += s[i];
          }
      }
      return r
  };
  
TrimString = function (s) {
    var i;
    var returnString = "";
    // Search through string's characters one by one.
    // If character is not a whitespace, append to returnString.
    for (i = 0; i < s.length; i++) {
        // Check that current character isn't whitespace.
        var c = s.charAt(i);
        if (c != " ") returnString += c;
    }
    return returnString;
};
	
Distance = function (lat1, lon1, lat2, lon2, unit) {
    var radlat1 = Math.PI * lat1 / 180;
    var radlat2 = Math.PI * lat2 / 180;
    var radlon1 = Math.PI * lon1 / 180;
    var radlon2 = Math.PI * lon2 / 180;
    var theta = lon1 - lon2;
    var radtheta = Math.PI * theta / 180;
    var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
    dist = Math.acos(dist);
    dist = dist * 180 / Math.PI;
    dist = dist * 60 * 1.1515;
    if (unit == "K") { dist = dist * 1.609344; }
    if (unit == "N") { dist = dist * 0.8684; }
    return dist;
};

KMPerLiterToLiterPer100KM = function (kmpl){
	if(kmpl > 0) return (100/kmpl);
	return 0;
}

StringToFloat = function(inValue){
	var val = parseFloat(inValue.replace(",", "."));
	if(isNaN(val)) val = 0;
	if(val == undefined) val = 0;
	return val;	
}

Bearing = function (lat1, lon1, lat2, lon2) {
    var radlat1 = Math.PI * lat1 / 180;
    var radlat2 = Math.PI * lat2 / 180;
    var radlon1 = Math.PI * lon1 / 180;
    var radlon2 = Math.PI * lon2 / 180;
    var dLat = (radlat2 - radlat1);
    var dLon = Math.PI * (lon2 - lon1) / 180;
    var y = Math.sin(dLon) * Math.cos(radlat2);
    var x = Math.cos(radlat1) * Math.sin(radlat2) - Math.sin(radlat1) * Math.cos(radlat2) * Math.cos(dLon);
    var brng = Math.atan2(y, x);
    brng = brng * 180 / Math.PI;
    return brng;
};
	
getMonday = function(d) {
  d = new Date(d);
  var day = d.getDay(),
      diff = d.getDate() - day + (day == 0 ? -6:1); // adjust when day is sunday
  return new Date(d.setDate(diff)).setHours(0, 0, 0, 0);
}

$.fn.inView = function(){
    //Window Object
    var win = $(window);
    //Object to Check
    obj = $(this);
    //the top Scroll Position in the page
    var scrollPosition = win.scrollTop();
    //the end of the visible area in the page, starting from the scroll position
    var visibleArea = win.scrollTop() + win.height();
    //the end of the object to check
    var objEndPos = (obj.offset().top + obj.outerHeight());
    return(visibleArea >= objEndPos && scrollPosition <= objEndPos ? true : false)
};

Date.prototype.isSameDateAs = function(pDate) {
  return (
    this.getFullYear() === pDate.getFullYear() &&
    this.getMonth() === pDate.getMonth() &&
    this.getDate() === pDate.getDate()
  );
}